<?php
//just in case it is needed
require_once('class.bm_periodengrafik.php');
/*
  If needed include additional modules of JPGraph here. 
  Calling it in the class results in trouble, most possibly because one would include a
  class in a class
*/
require_once('jpgraph_line.php');

class fertilitygrafik extends bm_periodengrafik //Fertilitygraph. More or less Normaldistribution
{
	/*
 	PHP does not call parent konstructors, thus do it yourself.
	Create/Set:
		- Title
		- Subtitle
	*/
  function fertilitygrafik($width,$height)
  {
		//Call the parent constructor to make basic settings
		$this->bm_periodengrafik($width,$height);
		//Set Title and Subtitle, Arial, Title:Bold und Subtitle:Italic
		$this->graph_object->title->Set(BM_TXT_GRAPH_TITLE_FERTILITY);
		$this->graph_object->title->SetFont(FF_ARIAL,FS_BOLD);
		$this->graph_object->subtitle->Set(BM_TXT_GRAPH_SUBTITLE_FERTILITY);
		$this->graph_object->subtitle->SetFont(FF_ARIAL,FS_ITALIC);
		//wtf this does
		//$this->graph_object->yaxis->scale->SetAutoMin(0);
		$this->graph_object->xaxis->title->Set(BM_TXT_GRAPH_XAXIS_TITLE_FERTILITY);
		$this->graph_object->yaxis->title->Set(BM_TXT_GRAPH_YAXIS_TITLE_FERTILITY); 
	}//END bm_fertilitygrafik
	
	/* addplot
	The implementation of the method given from bm_periodengrafik. This function will be used
  	to add the plot the graph and set its propertys
	- fillcolor for the graph
 	- drawcolor for the graph
  	- X x-title
  	- X y-title
	*/
	function addplot()
	{
 		/*
	 	Create a new lineplot from the data of the objects datacontainer (derived from bm_periodengrafik)
	 	The data in there came from translate_X_array().
	 	*/
		$p1 = new LinePlot($this->plot_data);
		$p1->SetFillColor(BM_COLOR_BLAU_MITTEL);
		//Finally add the created graph
		$this->graph_object->Add($p1);
	}
  
	/* translate_fertility_array
	   Translates $inputarray to possibilityvalues or drawable values for the graph
	   and returns the translated array as result.
	   Checks if the input is an Array or a String and converts it if necessary.
	   * LOGIC USED *
	   $counter=0,passedmiddle=false,targetarray
		 for each element
	   {
	   	 m=measure(element)
			 if m=zero targetarray[indexvariable]=0 //input=0 also output=0
	   	 else
	   	 {
	   			if (m=surround and passedmiddle=false) //before the middlepoint, rise
	   			{
	   			 	counter=counter+1
			 		 	targetarray[indexvar]=counter
					}
	   			else if m=middle //The middle, rise the last time, set passedmiddle to fall
					{
			 			passedmiddle=true
						counter=counter+1
			 			targetarray[indexvar]=counter
					} 
	   			else if (m=surround and passedmiddle=true) //behind the middlepoint, fall
	   			{
	   			 	counter=counter-1
			 		 	targetarray[indexvar]=counter
					}
	   	}		
		If the values exceed 100% or fall below 0%, they will be corrected to 100% or 0%
		* PARAMETER *
		$input The value coming from the mobile phone, either string or array.
		* RETURN *
		Nothing, the function fills the objects own data container
	*/
	function translate_fertility_array ($input,$factor=10,$min=0,$max=100)
  	{	
		$aux=new auxtools;
		//Test if its an array, if not convert it
		if (!is_array($input))
		{
			if (is_string($input))
		    	{
				//Convert to array
				$input=$aux->str_split($input);
		    	} else { // Not a string, but anything, quit with error
    				$aux->debug_out(gettype($input).' $input: '.$input);
				$aux->error(BM_OUT_DATAWRONG);
		    	}
    		}
    
		//Valuecounter, initialise with 0 since its a fertilitygraph
		$counter=0;
		$passedmiddle=false;
		$targetarray=array();
		//$aux->debug_out('input-var in translate:'.nl2br(var_dump($input)));
		
		foreach ($input as $work)
	  	{
			$m=-1;
		  	//$aux->debug_out('foreach: work: '.$work.' type: '.gettype($work));
			$m=$this->measure($work);
			//$aux->debug_out(' measure-result: '.$m.' passedmiddle: '.$passedmiddle);
  			if ($m==BM_MEASURE_ZERO)//($work=='0')
  			{
  				array_push($targetarray,0); //input=0, thus append 0 to the targetarry
  				//$aux->debug_out('translate if: zero branch');
	  		}else
			{
				if ($m==BM_MEASURE_SURROUND and $passedmiddle==false) //before the middlepoint, rise 
  				{
    					//rise the counter one factor
					$counter=$counter+$factor;
  	 				//Correct if max or min are exceeded
  	 				if ($counter>$max)
						{$counter=$max;}
	  	 			else if ($counter<$min)
					  	{$counter=$min;}
					array_push($targetarray,$counter); //add the current value to the targetarray
  	 		 		//$aux->debug_out('translate if: surround passed=false');
				}
  				else if ($m==BM_MEASURE_MIDDLE) //the middlepoint, rise a last one, set passedmidle to fall 
				{
  	 				$passedmiddle=true;
	  				$counter=$counter+$factor;
					//Correct if max or min are exceeded
	  	 			if ($counter>$max)
						  {$counter=$max;}
	  	 			else if ($counter<$min)
						  {$counter=$min;}
					//Add to the array
	  	 			array_push($targetarray,$counter);
	  	 			//$aux->debug_out('translate if: middle');
				} 
	  			else if ($m==BM_MEASURE_SURROUND and $passedmiddle==true) //behind the middlepoint, fall
	  			{
	    			$counter=$counter-$factor;
    				//Correct if max or min are exceeded
  	 			if ($counter>$max)
					  {$counter=$max;}
  	 			else if ($counter<$min)
					  {$counter=$min;}
				//Add to the array
  	 		 	array_push($targetarray,$counter);
  	 		 	//$aux->debug_out('translate if: surround passedmiddle=true');
	 		 	}
			}//END if
			//$aux->debug_out('end foreach, work '.$work.' counter '.$counter.'<br>');
	  	}//END foreach
    		//debug
 	   	//$aux->debug_out('input-var in translate:'.nl2br(var_dump($targetarray)));
	    	$this->plot_data=$targetarray;
	}//END translate_fertility_array
}//END class fertilitygrafik

//### DEBUG ###
$deb=new auxtools();
//$backtrace=debug_backtrace();
//$deb->debug_out(__FILE__.' OK<br>'.'(in '.__FILE__.', Line: '.__LINE__.', Function: '.__FUNCTION__.')<br>');
?>